# platform-ui-components

A collection of reusable UI components used across various applications built by the Platform team.

These components depend on the Google's Angular 1.x JS implementation of their
Material Design spec. Where possible we have followed the Material Design spec
to the letter.

Since these are private modules for now you will need to install them using a fully qualified url:

```shell
bower install https://github.com/OrbotixInc/platform-ui-components.git
```

## <a name="releasing"></a> Our Release Processes

This project follows the SemVar versioning process which can be described in the following manner.

*  `major` :  Fundamental changes to the nature of the project, which would constitute a major reworking of the codebase.
*  `minor`:  aka `master` contains patch release changes AND breaking changes and new features
*  `patch`:  non-breaking changes (no API, CSS, UX changes that will cause breaks in existing `spheroPlatform` applications)

##### Patch Releases

The patch builds (1.0.4, 1.0.5, 1.0.6) are prepared based on commits in the `patch` branch; which contains only non-breaking changes (eg bug fix, some API additions, minimal non-breaking CSS changes ).  We will be building `patch` releases every week.

##### Minor Releases

The minor build (1.1.0, 1.2.0, 1.3.0,...) are prepared based on commits in the `master` branch; which will remain the daily development branch AND will be the source for the `minor` releases.

Our formal release of `minor` builds is much less frequent; probably 1x / Quarter. Developers can easily obtain the latest, full change-set from bower or npm using references to `@master`.


## <a name="building"></a> Building

Developers can easily build spheroPlatform using NPM and gulp.

First install or update your local project's **npm** tools:

```bash
# First install all the NPM tools:
npm install

# Or update
npm update
```

Then run the **gulp** tasks:

```bash
# To build `platform-ui-components.js/.css` files in the `/dist` directory
gulp build

# To release a new version
gulp release
```

Once you have all the necessary assets installed, add `spheroPlatform` as a dependency for your app:

```javascript
angular.module('myApp', ['spheroPlatform']);
```
