'use strict';

var path = require('path');
var gulp = require('gulp');
var conf = require('./conf');
var sass = require('gulp-sass');
var concat = require('gulp-concat');


var $ = require('gulp-load-plugins')({
  pattern: ['gulp-*', 'main-bower-files', 'uglify-save-license', 'del']
});

gulp.task('sass', function () {
  return gulp.src(path.join(conf.paths.src, '/modules/**/*.sass'))
    .pipe($.sourcemaps.init())
    .pipe(sass.sync().on('error', sass.logError))
    .pipe(concat(conf.projectName + '.css'))
    .pipe($.sourcemaps.write('maps'))
    .pipe(gulp.dest(path.join(conf.paths.dist, '/')))
    .pipe($.size({
      title: path.join(conf.paths.dist, '/'),
      showFiles: true
    }));
});

gulp.task('scripts', function () {
  var jsFilter = $.filter('**/*.js', {
    restore: true
  });

  return gulp.src(path.join(conf.paths.src, '/modules/**/*.js'))
    .pipe(jsFilter)
    .pipe($.sourcemaps.init())
    .pipe($.ngAnnotate())
    .pipe(concat(conf.projectName + '.js'))
    .pipe($.uglify({
      preserveComments: $.uglifySaveLicense
    })).on('error', conf.errorHandler('Uglify'))
    .pipe($.sourcemaps.write('maps'))
    .pipe(jsFilter.restore)
    .pipe(gulp.dest(path.join(conf.paths.dist, '/')))
    .pipe($.size({
      title: path.join(conf.paths.dist, '/'),
      showFiles: true
    }));
});

gulp.task('clean', function () {
  return $.del([path.join(conf.paths.dist, '/'), path.join(conf.paths.tmp, '/')]);
});

gulp.task('build', ['sass', 'scripts']);