/**
 *  Welcome to your gulpfile!
 *  The gulp tasks are splitted in several files in the gulp directory
 *  because putting all here was really too long
 */

'use strict';

var gulp = require('gulp');
var wrench = require('wrench');
require('gulp-release-it')(gulp);
var shell = require('gulp-shell');

/**
 *  This will load all js files in the gulp directory
 *  in order to load all gulp tasks
 */
wrench.readdirSyncRecursive('./gulp').filter(function (file) {
  return (/\.(js)$/i).test(file);
}).map(function (file) {
  require('./gulp/' + file);
});

gulp.task('pushTags', shell.task(['git push origin --tags']));

/**
 *  Default task clean temporaries directories and launch the
 *  main optimization build task
 */
gulp.task('default', ['clean'], function () {
  gulp.start('build');
});

/**
 * Provides an automatic way to do a release of your npm modules to GitHub.
 *
 * Creates a tag based on version specified in package.json
 * Publish to GitHub
 * Bumps the version of package.json, bower.json or/and manifest.json
 */
gulp.task('github-release', ['clean', 'build'], function () {
  gulp.start('github-release');
  gulp.start('pushTags');
});