(function () {
  'use strict';
  /**
   * @ngdoc directive
   * @name gravatar
   * @module sphero.directives.gravatar
   * @restrict E
   *
   * @description
   *
   * A directive that displays the currentAccount's gravatar
   *
   * @usage
   *
   * HAML example:
   * %gravatar(email="email" size="100")
   */
  var gravatar = function () {
    return {
      restrict: 'E',
      template: '<img ng-src="{{gravatarUrl}}">',
      scope: {
        email: '=',
        size: '='
      },
      controller: ['$scope', function ($scope) {
        $scope.imageSize = $scope.size || 100;
        $scope.$watch('email', function (newer) {
          if (angular.isDefined(newer)) {
            $scope.hashedEmail = CryptoJS.MD5(newer).toString();
            $scope.gravatarUrl = 'http://www.gravatar.com/avatar/' + $scope.hashedEmail + '?d=retro&s=' + $scope.imageSize;
          }
        });
      }]
    };
  };

  angular.module('spheroPlatform.directives')
    .directive('gravatar', gravatar);
})();