(function () {
  'use strict';
  /**
   * @ngdoc directive
   * @name moreMenu
   * @module sphero.directives.profileCard
   * @restrict E
   *
   * @description
   *
   * A directive that displays the currentAccount details
   *
   * @usage
   *
   * HAML example:
   * %profile-card(current-account="currentAccount")
   */
  var profileCard = function () {
    return {
      restrict: 'E',
      templateUrl: 'profile-card.html',
      scope: {
        currentAccount: '='
      },
      controller: ['$scope', function ($scope) {
        $scope.$watch('currentAccount', function (newer) {
          if (angular.isDefined(newer)) {
            $scope.hashedEmail = CryptoJS.MD5(newer.email).toString();
            $scope.gravatar = 'http://www.gravatar.com/avatar/' + $scope.hashedEmail + '?d=retro&s=100';
          }
        });
      }]
    };
  };

  angular.module('spheroPlatform.directives')
    .directive('profileCard', profileCard);
})();